﻿using Serenity.Web;
using Syncfusion.JavaScript;
using System;
using System.Collections.Specialized;
using System.IO;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace FileExplorerMVC
    {
        [RoutePrefix("DocumentsManagement/FileExplorer"), Route("{action=index}")]

        public class FileExplorerController : Controller
        {
            public ActionResult Index()
            {
                return View(MVC.Views.DocumentsManagement.FileExplorer.Index);
            }
            [Route("FileActionDefault")]
            public ActionResult FileActionDefault()
            {
                FileExplorerOperations opeartion = new FileExplorerOperations();
                FileExplorerParams args = GetAjaxData();                
                switch (args.ActionType)
                {
                    case "Read":
                        return Json(opeartion.Read(args.Path, args.ExtensionsAllow));
                    case "CreateFolder":
                        return Json(opeartion.CreateFolder(args.Path, args.Name));
                    case "Paste":
                        return Json(opeartion.Paste(args.LocationFrom, args.LocationTo, args.Names, args.Action, args.CommonFiles));
                    case "Remove":
                        return Json(opeartion.Remove(args.Names, args.Path));
                    case "Rename":
                        return Json(opeartion.Rename(args.Path, args.Name, args.NewName, args.CommonFiles));
                    case "GetDetails":
                        return Json(opeartion.GetDetails(args.Path, args.Names));
                    case "Download":
                        opeartion.Download(args.Path, args.Names);
                        break;
                    case "Search":
                        return Json(opeartion.Search(args.Path, args.ExtensionsAllow, args.SearchString, args.CaseSensitive));                 
                }
                return Json("");
            }
            private Syncfusion.JavaScript.FileExplorerParams GetAjaxData()
            {
                var serializer = new JavaScriptSerializer();
                FileExplorerOperations operation = new FileExplorerOperations();
                var req = ControllerContext.HttpContext.Request;                
                req.InputStream.Seek(0, SeekOrigin.Begin);
                var jsonStringData = new StreamReader(req.InputStream).ReadToEnd();
                FileExplorerParams args = new FileExplorerParams();
                if ((HttpContext.Request).Files.Count > 0)
                {
                    HttpFileCollectionBase files = (HttpContext.Request).Files;
                    args.Path = (HttpContext.Request).QueryString.Get("Path");
                    args.ActionType = "Upload";
                    try
                    {
                        for (int i = 0; i < files.Count; i++)
                        {
                            var fileName = Path.GetFileName(files[i].FileName);
                            var destinationPath = Path.Combine(operation.GetPhysicalPath(operation.ToAbsolute(args.Path)), fileName);
                            files[i].SaveAs(destinationPath);
                        }
                    }
                    catch (Exception ex) { throw ex; }   
                }
                else
                {
                    if ((HttpContext.Request).HttpMethod.ToLower() == "get")
                    {                        
                        try
                        {
                            args.ActionType = (HttpContext.Request).QueryString.Get("ActionType");
                            args.Path = (HttpContext.Request).QueryString.Get("Path");
                            args.Names = (HttpContext.Request).QueryString.GetValues("Names");
                        }
                        catch (Exception ex) { throw ex; }
                    }
                    else
                    {
                        args = (FileExplorerParams)serializer.Deserialize(jsonStringData, typeof(FileExplorerParams));
                    }                    
                }
                       
                return args;
            }
        }
    }

